<table>
  <tr>
    <td width="200">
     <img src="/icon.png" alt="Module icon"/>
    </td>
    <td>
     <h2>PhoneMiddleware for FreePBX</h2>
     <span>Simple module to read a carddav server and return inbound CNAM, Outbound CNAM and XML phonebook.</span>
     <br>
     <span>Module for FreePBX systems, tested with 15/16+ (default distro) and Baikal as the backend.</span>
    </td>
  </tr>
</table>

## Purpose
Do you have a carddav based system but your SIP phones are only compatible with LDAP? All fine, here is the solution!
I've done lot of researches but never found what i was looking for, so I made this, a module to get incoming and outcoming CNAM (read: caller ID or name) and a full XML phone book that can be read by your phone (or even other devices!).

## Installation and Usage
1. The Module depends on [outbound-CNAM](http://pbxossa.org/files/outcnam/). Please upload it through "Module Admin" before continuing, then enable all the options and leave the Scheme on `'ALL'`
2. Upload the [package](https://github.com/Massi-X/freepbx-phonemiddleware/releases/latest/)) through "Module Admin" and install it
3. Go to Applications > Phone MiddleWare and fill everything with your personal data

_**How to read the XML phonebook:**_
- Open the module interface on the bottom link to open a dialog where you can see the url to input on your phone

_**How to enable inbound CNAM:**_
- To enable inbound CNAM create a Caller ID Lookup source and set the parameters (you can find them in the module interface on the bottom link), then match it with your inbound route(s) (Inbound route->_your_route_->Other->CID Lookup Source)

_**How to enable outbound CNAM:**_
 - To enable outbound CNAM follow this steps:
    - Go into CID Superfecta, delete all the existing entries and create a new one with this settings:
      ```
      - Scheme Name: As you want
      - Lookup timeout: 5 (it's usually enough)
      - Superfecta Processor: SINGLE
      ```
  - Save and enter the configuration by clicking on the scheme name, then turn OFF all the schemes but Regular Expressions 1, click the gear icon and set the parameters (you can find them in the module interface on the bottom link

<details>
 <summary>Notes</summary>
  
 - **USE THIS ONLY INSIDE AN INTERNAL TRUSTED NETWORK, DOESN'T HAVE ANY TYPE OF SECURITY**
 - This does always returns a CNAM in CID superfecta (even if it doesn't find a match), so it's not compatible with other schemes
 - If a vcard number field is empty, it won't be displayed at all (not an issue)
</details>

## Donation
If you like to support me, you can donate. Any help is greatly appreciated. Thank you!<br>
Bitcoin: <b>1Pig6XJxXGBj1v3r6uLrFUSHwyX8GPopRs</b>
<br>
Monero: <b>89qdmpDsMm9MUvpsG69hbRMcGWeG2D26BdATw1iXXZwi8DqSEstJGcWNkenrXtThCAAJTpjkUNtZuQvxK1N5xSyb18eXzPD</b>
<br>
Donate to PayPal: [![paypal](https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif)](https://www.paypal.com/donate?hosted_button_id=JG8QUZPEH3KBG)

## License
`SPDX-License-Identifier: The-Prosperity-Public-License-3.0.0`<br>
This work is licensed under The Prosperity Public License 3.0.0.<br>
You have to agree if you use this module.<br>
In short this means: You can't use this lib for commercial use without clear agreements with the author but you can freely use it for personal use.<br>
Licenses for the included modules are available below. Credits go to the original author only.<br>
- [Carddav-PHP](https://github.com/christian-putzke/CardDAV-PHP/)
- [vCard-parser](https://github.com/nuovo/vCard-parser/)
- [libphonenumber for PHP](https://github.com/giggsey/libphonenumber-for-php/)
- [Composer](https://github.com/composer/composer/)