<?php
header('Content-type: text/plain');

require_once 'phoneMiddleware.php';
$phoneMiddleware = new phoneMiddleware();

//call it this way for module update check: php exec script	MODE
//															$argv[1]

if ($argv[1] == phoneMiddleware::MODE_CHECK_UPDATES) {
	$newVersion = $phoneMiddleware->check_module_update();
	if ($newVersion !== false) {
		$mailPattern = '/(?:[a-z0-9+!#$%&\'*+\/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&\'*+\/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])/im';

		//execute pre-shell scripts
		$msmList = shell_exec("fwconsole msm -l");
		$setList = shell_exec("fwconsole set -l");

		//extract "to" address from fpbx database
		preg_match('/^.+notification_emails.+$/im', $msmList, $res);
		preg_match($mailPattern, $res[0], $res);
		$to = $res[0];

		//extract "from" address from fpbx database
		preg_match('/^.+AMPUSERMANEMAILFROM.+$/im', $setList, $res);
		preg_match($mailPattern, $res[0], $res);
		if(empty($res[0])) $res[0] = $to; //trying to send email anyway using the "to" address
		$from = "PM Update Check <".$res[0].">";

		//extract server name from fpbx database
		preg_match('/^.+FREEPBX_SYSTEM_IDENT.+$/im', $setList, $res);
		preg_match('/\|.*?\|(.*)\|.*?\|/im', $res[0], $res);
		$serverName = trim($res[1]);

		$subject = "PhoneMiddleware Update Notification (".$serverName.")";
		$txt = "There is an update available for PhoneMiddleware (Current version: ".$phoneMiddleware->get_version()." - Online version: ".$newVersion.").<br><br>Please download it from <a href=\"".phoneMiddleware::GITHUB_RELEASE_URL."\">here</a> and install it through the Module Admin interface.";
		$htmlBody =
			"To: ".$to."\r\n" .
			"From: ".$from."\r\n" .
			"Subject: ".$subject."\r\n" .
			"Content-Type: text/html\r\n" .
			"MIME-Version: 1.0\r\n" .
			"<html><head><title>".$subject."</title></head><body><p>".$txt."</p></body></html>\r\n";

		exec("echo -e \"$htmlBody\" | sendmail -t", $output, $exitCode);

		if ($exitCode == 0) exit("Some updates are available! Mail sent to the registered email address.\r\n");
		else exit("Some updates are available, but I was unable to send an email to the registered email address!\r\n");
	}
	exit("Update check completed. No updates available.\r\n");
}

//call it this way for phonebook update: php exec script	MODE		HTTP_URL	USERNAME	PASSWORD	EXPIRE_TIME	PHONETYPE (IF MODE = MODE_PHONEBOOK_REFRESH)
//															$argv[1]	$argv[2]	$argv[3]	$argv[4]	$argv[5]	$argv[6]

$phoneMiddleware->set_url($argv[2]);
$phoneMiddleware->set_auth($argv[3], $argv[4]);
$phoneMiddleware->set_cache_expire($argv[5]);
$phoneMiddleware->set_phone_type($argv[6]);
$phoneMiddleware->init();

if (!$phoneMiddleware->request_clear_cache($argv[1])) die("Unable to acquire lock or update already requested!\r\n");

try {
	if ($argv[1] == phoneMiddleware::MODE_PHONEBOOK_REFRESH) $phoneMiddleware->getXMLforPhones(true);
	else if ($argv[1] == phoneMiddleware::MODE_RELOAD_VCARD) $phoneMiddleware->getAllVcards(true);
} catch(Exception $e) {
	//don't care about exceptions
}

exit("Cards updated\r\n");
?>